/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package applets;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.net.MalformedURLException;
import java.net.URL;
import javax.swing.JMenu;


/**
 *
 * @author Mark Pendergast
 */
public class MenuApplet extends javax.swing.JApplet {
    private String target = "_self";
    /**
     * Initializes the applet MenuApplet
     */
    @Override
    public void init() {

        /* Create and display the applet */
        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {
                public void run() {
                    initComponents();
                }
            });
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
        //
        // get the target of the showDocument calls
        //
        target = this.getParameter("Target");
        if(target == null)
            target="_self";  // assume self if the parameter is missing
        //
        // access the font information from the parameters
        //
        String fontsize = this.getParameter("fontsize");
        String fontfamily = this.getParameter("fontfamily");
        String fontcolor = this.getParameter("fontcolor");
        String bgcolor = this.getParameter("bgcolor");
        //
        // create the font and the oolors if all parameters are present
        //
        if(fontsize != null && fontfamily != null && fontcolor != null)
        {
         Font menuFont;   
         Color fcolor = Color.BLACK;
         Color bcolor = Color.WHITE;
          try{
            int size = Integer.parseInt(fontsize);
            int colorf = Integer.parseInt(fontcolor,16);
            int colorb = Integer.parseInt(bgcolor,16);
            menuFont = new Font(fontfamily, Font.PLAIN, size);
            fcolor = new Color(colorf);
            bcolor = new Color(colorb);
            
            synchronized(menuBar.getTreeLock())  // protect the UI 
            {
             menuBar.setBackground(bcolor); // set the menu bar background                
             Component[] comps = menuBar.getComponents(); // get all the top level components
             for(int i = 0; i < comps.length; i++) 
             {
              setMenuFonts(comps[i],menuFont, fcolor,bcolor);  // recusive set fonts for all sub menus
             }
            }
          }
          catch(NumberFormatException nfex)
          {
            // any parsing errors will cause the default fonts to be used. 
          }
        }
    }
/**
 * Recursively set all the fonts and colors for the JMenu or JMenuItem component passed in.
 * 
 * @param c - Component (JMenu or JMenuItem)
 * @param f - font
 * @param fcolor - foreground color
 * @param bcolor - background color
 */
    private void setMenuFonts(Component c, Font f, Color fcolor, Color bcolor)
    {      
     //
     // set the properties
     c.setForeground(fcolor);
     c.setBackground(bcolor);
     c.setFont(f);
     //
     // recurse only if it is a JMenu
     //
     if(c instanceof JMenu)
     {
       ((JMenu)c).setOpaque(true);  // force the JMenus to be opaque
       Component[] comps = ((JMenu)c).getMenuComponents();
       for(int i = 0; i < comps.length; i++)
       {
        setMenuFonts(comps[i],f,fcolor,bcolor); // recurse for each sub item   
       }
     }        
    }
    /**
     * This method is called from within the init() method to initialize the
     * form. WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        menuBar = new javax.swing.JMenuBar();
        newsMenu = new javax.swing.JMenu();
        cnnItem = new javax.swing.JMenuItem();
        foxItem = new javax.swing.JMenuItem();
        cbsItem = new javax.swing.JMenuItem();
        sportsMenu = new javax.swing.JMenu();
        footballMenu = new javax.swing.JMenu();
        nflItem = new javax.swing.JMenuItem();
        ncaaFootballItem = new javax.swing.JMenuItem();
        baseballMenu = new javax.swing.JMenu();
        mlbItem = new javax.swing.JMenuItem();
        ncaaBaseballItem = new javax.swing.JMenuItem();
        basketballMenu = new javax.swing.JMenu();
        nbaItem = new javax.swing.JMenuItem();
        ncaaBasketballItem = new javax.swing.JMenuItem();
        weatherMenu = new javax.swing.JMenu();
        twcItem = new javax.swing.JMenuItem();
        undergroundItem = new javax.swing.JMenuItem();
        accuItem = new javax.swing.JMenuItem();

        newsMenu.setText("News");
        newsMenu.setOpaque(true);

        cnnItem.setText("CNN News");
        cnnItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cnnItemActionPerformed(evt);
            }
        });
        newsMenu.add(cnnItem);

        foxItem.setText("Fox News");
        foxItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                foxItemActionPerformed(evt);
            }
        });
        newsMenu.add(foxItem);

        cbsItem.setText("CBS News");
        cbsItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbsItemActionPerformed(evt);
            }
        });
        newsMenu.add(cbsItem);

        menuBar.add(newsMenu);

        sportsMenu.setText("Sports");
        sportsMenu.setOpaque(true);

        footballMenu.setText("Football");
        footballMenu.setOpaque(true);

        nflItem.setText("NFL");
        nflItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nflItemActionPerformed(evt);
            }
        });
        footballMenu.add(nflItem);

        ncaaFootballItem.setText("NCAA Football");
        ncaaFootballItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ncaaFootballItemActionPerformed(evt);
            }
        });
        footballMenu.add(ncaaFootballItem);

        sportsMenu.add(footballMenu);

        baseballMenu.setText("Baseball");

        mlbItem.setText("Major League Baseball");
        mlbItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mlbItemActionPerformed(evt);
            }
        });
        baseballMenu.add(mlbItem);

        ncaaBaseballItem.setText("NCAA Baseball");
        ncaaBaseballItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ncaaBaseballItemActionPerformed(evt);
            }
        });
        baseballMenu.add(ncaaBaseballItem);

        sportsMenu.add(baseballMenu);

        basketballMenu.setText("Basketball");

        nbaItem.setText("NBA");
        nbaItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nbaItemActionPerformed(evt);
            }
        });
        basketballMenu.add(nbaItem);

        ncaaBasketballItem.setText("NCAA Basketball");
        ncaaBasketballItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ncaaBasketballItemActionPerformed(evt);
            }
        });
        basketballMenu.add(ncaaBasketballItem);

        sportsMenu.add(basketballMenu);

        menuBar.add(sportsMenu);

        weatherMenu.setText("Weather");

        twcItem.setText("The Weather Channel");
        twcItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                twcItemActionPerformed(evt);
            }
        });
        weatherMenu.add(twcItem);

        undergroundItem.setText("Weather Underground");
        undergroundItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                undergroundItemActionPerformed(evt);
            }
        });
        weatherMenu.add(undergroundItem);

        accuItem.setText("Accu Weather");
        accuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                accuItemActionPerformed(evt);
            }
        });
        weatherMenu.add(accuItem);

        menuBar.add(weatherMenu);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 416, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 93, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void cnnItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cnnItemActionPerformed

        try{
            URL link = new URL("http://www.cnn.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.cnn.com");
     } 
    }//GEN-LAST:event_cnnItemActionPerformed

    private void foxItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_foxItemActionPerformed

          try{
            URL link = new URL("http://www.foxnews.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.foxnews.com");
     } 
    }//GEN-LAST:event_foxItemActionPerformed

    private void cbsItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbsItemActionPerformed
       
  try{
            URL link = new URL("http://www.cbsnews.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.cbsnews.com");
     }         
    }//GEN-LAST:event_cbsItemActionPerformed

    private void nflItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nflItemActionPerformed
         try{
            URL link = new URL("http://www.nfl.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.nfl.com");
     } 
    }//GEN-LAST:event_nflItemActionPerformed

    private void ncaaFootballItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ncaaFootballItemActionPerformed
  try{
            URL link = new URL("http://www.ncaafootball.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.ncaafootball.com");
     } 
        
    }//GEN-LAST:event_ncaaFootballItemActionPerformed

    private void mlbItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mlbItemActionPerformed
  try{
            URL link = new URL("http://www.mlb.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.mlb.com");
     } 
    }//GEN-LAST:event_mlbItemActionPerformed

    private void ncaaBaseballItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ncaaBaseballItemActionPerformed

        try{
            URL link = new URL("http://www.ncaa.com/sports/baseball/d1");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.ncaa.com/sports/baseball/d1");
     }      
    }//GEN-LAST:event_ncaaBaseballItemActionPerformed

    private void nbaItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nbaItemActionPerformed
    try{
            URL link = new URL("http://www.nba.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.nba.com");
     }         
    }//GEN-LAST:event_nbaItemActionPerformed

    private void ncaaBasketballItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ncaaBasketballItemActionPerformed
       try{
        URL link = new URL("http://www.ncaa.com/sports/basketball-men/d1");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.ncaa.com/sports/basketball-men/d1");
         }
    }//GEN-LAST:event_ncaaBasketballItemActionPerformed

    private void twcItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_twcItemActionPerformed
         try{
            URL link = new URL("http://www.weather.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.weather.com");
     } 
    }//GEN-LAST:event_twcItemActionPerformed

    private void undergroundItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_undergroundItemActionPerformed
   try{
            URL link = new URL("http://www.wunderground.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.wunderground.com");
     } 
    }//GEN-LAST:event_undergroundItemActionPerformed

    private void accuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_accuItemActionPerformed
        try{
            URL link = new URL("http://www.accuweather.com");
            getAppletContext().showDocument(link,target);
       }

         catch(MalformedURLException ex) {
              showStatus("Bad URL: http://www.accuweather.com");
     } 
    }//GEN-LAST:event_accuItemActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem accuItem;
    private javax.swing.JMenu baseballMenu;
    private javax.swing.JMenu basketballMenu;
    private javax.swing.JMenuItem cbsItem;
    private javax.swing.JMenuItem cnnItem;
    private javax.swing.JMenu footballMenu;
    private javax.swing.JMenuItem foxItem;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem mlbItem;
    private javax.swing.JMenuItem nbaItem;
    private javax.swing.JMenuItem ncaaBaseballItem;
    private javax.swing.JMenuItem ncaaBasketballItem;
    private javax.swing.JMenuItem ncaaFootballItem;
    private javax.swing.JMenu newsMenu;
    private javax.swing.JMenuItem nflItem;
    private javax.swing.JMenu sportsMenu;
    private javax.swing.JMenuItem twcItem;
    private javax.swing.JMenuItem undergroundItem;
    private javax.swing.JMenu weatherMenu;
    // End of variables declaration//GEN-END:variables
}
